package szakdolgozat;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.image.BufferedImage;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Calendar;

import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.KeyStroke;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

public class AppWindow {
	StorageTabbedPane storageTabbedPane;
	boolean isSavedImage = false;
	boolean isSavedWorkingArea = false;
	File imageFile = null;
	File workspacefile = null;
	File logfile=null;
	JFrame mainFrame;
	final JFileChooser fc3 = new JFileChooser();


	public AppWindow() {
		storageTabbedPane = new StorageTabbedPane();
	}

	public StorageTabbedPane getStorageTabbedPane() {
		return storageTabbedPane;
	}

	public void createLogFile() {

	}

	public void newWorkingArea() {
		storageTabbedPane.workingareastoragepanel.coordinatesystempanel.components = null;
		storageTabbedPane.workingareastoragepanel.coordinatesystempanel.transformedShapes = null;
		storageTabbedPane.workingareastoragepanel.coordinatesystempanel.nonLinearTransformedShapes = null;
		storageTabbedPane.workingareastoragepanel.coordinatesystempanel.coloringNonLinTransformedShapes=null;
		storageTabbedPane.workingareastoragepanel.coordinatesystempanel.coloringTransformedShapes=null;
		storageTabbedPane.workingareastoragepanel.coordinatesystempanel
		.repaint();
		isSavedWorkingArea = false;
		storageTabbedPane.workingareastoragepanel.coordinatesystempanel.isChanged = false;
	}

	public void saveWorkingArea(){
		if (isSavedWorkingArea == false) {
			fc3.setFileFilter(new WorkspaceFilter());
			fc3.setAcceptAllFileFilterUsed(false);
			int returnVal = fc3.showSaveDialog(mainFrame);
			if (returnVal == JFileChooser.APPROVE_OPTION) {
				File file = fc3.getSelectedFile();
				isSavedWorkingArea = true;
				File outputfile;
				if (file.getName().contains(".tdif")) {
					outputfile = new File(file.getPath());
				} else {
					outputfile = new File(file.getPath() + ".tdif");
				}
				FileSaver newfilesaver = new FileSaver(
						outputfile,
						storageTabbedPane.workingareastoragepanel.coordinatesystempanel.components);
				newfilesaver.writeToFile();
				workspacefile = outputfile;
				System.out.println(file.getPath() + file.getName());
			} else {
				System.out.println("Save command cancelled by user");
			}
		} else {
			FileSaver newfilesaver = new FileSaver(
					workspacefile,
					storageTabbedPane.workingareastoragepanel.coordinatesystempanel.components);
			newfilesaver.writeToFile();
		}
		File imagefile=createSnapshot(storageTabbedPane.workingareastoragepanel.coordinatesystempanel, workspacefile.getPath().replaceAll("tdif$", "png"));

		logfile=new File(workspacefile.getName()+".log");

		try{
			if(logfile.exists()){
				FileWriter fstream=new FileWriter(logfile, true);
				BufferedWriter out = new BufferedWriter(fstream);
				out.write(Calendar.getInstance().get(Calendar.YEAR)+"."+Calendar.getInstance().get(Calendar.MONTH)+"."+Calendar.getInstance().get(Calendar.DATE)
						+" "+Calendar.getInstance().get(Calendar.HOUR_OF_DAY)+":"+Calendar.getInstance().get(Calendar.MINUTE)
						+":"+Calendar.getInstance().get(Calendar.SECOND)+ " "+workspacefile.getName()+" "+imagefile.getName());
				out.close();
			}
			else{
				FileWriter fstream=new FileWriter(logfile, false);
				BufferedWriter out = new BufferedWriter(fstream);
				out.write(Calendar.getInstance().get(Calendar.YEAR)+"."+Calendar.getInstance().get(Calendar.MONTH)+"."+Calendar.getInstance().get(Calendar.DATE)
						+" "+Calendar.getInstance().get(Calendar.HOUR_OF_DAY)+":"+Calendar.getInstance().get(Calendar.MINUTE)
						+":"+Calendar.getInstance().get(Calendar.SECOND)+ " "+workspacefile.getName()+" "+imagefile.getName());
				out.close();
			}
		}catch(IOException e){
			e.printStackTrace();
		}
	}

	private File createSnapshot(JPanel panel, String filePath) {
		try {
			BufferedImage bufImage = new BufferedImage(panel.getSize().width, panel.getSize().height, BufferedImage.TYPE_INT_RGB);
			panel.paint(bufImage.createGraphics());
			File imageFile = new File(filePath);
			imageFile.createNewFile();
			ImageIO.write(bufImage, "png", imageFile);
			return imageFile;
		} catch (IOException e) {
			e.printStackTrace();
			return null;
		}
	}

	public void openWorkspace(JFileChooser fc, JMenuItem openWorkspace) {
		int returnVal = fc.showOpenDialog(openWorkspace);

		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File file = fc.getSelectedFile();
			System.out.println(file.getName());
			workspacefile = file;
			isSavedWorkingArea = true;

			storageTabbedPane.getWorkingAreaStoragePanel()
			.getCoordinateSystemPanel().addComponentsFromFile(file);
			storageTabbedPane.setSelectedIndex(0);
			storageTabbedPane.workingareastoragepanel.coordinatesystempanel.isChanged = false;
		} else {
			System.out.println("Open command cancelled by user.");
		}
		fc.setSelectedFile(null);
	}

	public void openPicture(JFileChooser fc2, JMenuItem openPicture) {
		System.out.println("Picture Panel");

		int returnVal = fc2.showOpenDialog(openPicture);

		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File file = fc2.getSelectedFile();
			System.out.println(file.getName());
			storageTabbedPane.getImageEditStoragePanel().getImagePanel().pictureOnPanel = null;
			storageTabbedPane.getImageEditStoragePanel().getImagePanel()
			.setPictureOnPanel(file);
			storageTabbedPane.setSelectedIndex(1);
			storageTabbedPane.imageeditstoragepanel.imagepanel.isTransformed = false;

		} else {
			System.out.println("Open command cancelled by user.");
		}
		fc2.setSelectedFile(null);
	}

	public void savePicture() {
		if (storageTabbedPane.imageeditstoragepanel.imagepanel.pictureOnPanel != null) {
			if (isSavedImage == false) {
				fc3.setFileFilter(new ImageFilter());
				fc3.setAcceptAllFileFilterUsed(false);
				int returnVal = fc3.showSaveDialog(mainFrame);
				if (returnVal == JFileChooser.APPROVE_OPTION) {
					File file = fc3.getSelectedFile();
					isSavedImage = true;
					BufferedImage bi = storageTabbedPane.imageeditstoragepanel.imagepanel.pictureOnPanel;
					if (bi != null) {
						File outputfile;
						if (file.getName().contains(".png")
								|| file.getName().contains(".jpg")
								|| file.getName().contains(".jpeg")
								|| file.getName().contains(".bmp")
								|| file.getName().contains(".gif")) {
							outputfile = new File(file.getPath());
						} else {
							outputfile = new File(file.getPath() + ".png");
						}
						imageFile = outputfile;
						try {
							ImageIO.write(bi, "png", outputfile);
						} catch (IOException e1) {
							e1.printStackTrace();
							System.out.println("HIBA");
						}
					}
					System.out.println(file.getPath() + file.getName());
				} else {
					System.out.println("Save command cancelled by user");
				}
			} else {
				BufferedImage bi = storageTabbedPane.imageeditstoragepanel.imagepanel.pictureOnPanel;
				try {
					ImageIO.write(bi, "png", imageFile);
				} catch (IOException e1) {
					e1.printStackTrace();
					System.out.println("HIBA");
				}
			}
		} else {
			JOptionPane.showMessageDialog(mainFrame, "Nincs menthető kép",
					"Mentés hiba", JOptionPane.ERROR_MESSAGE);
		}
	}

	public void setMenu(TransformationSwMenuBar menubar) {
		JMenu filemenu = new JMenu("Fájl");
		filemenu.setMnemonic(KeyEvent.VK_F10);
		filemenu.getAccessibleContext().setAccessibleDescription(
				"A fájl műveleteket végző menü");
		menubar.add(filemenu);

		JMenuItem newWorkspaceMenuItem = new JMenuItem("Új munkalap");
		newWorkspaceMenuItem.setAccelerator(KeyStroke.getKeyStroke(
				KeyEvent.VK_N, ActionEvent.CTRL_MASK));
		newWorkspaceMenuItem.getAccessibleContext().setAccessibleDescription(
				"Új munkalap létrehozása");
		filemenu.add(newWorkspaceMenuItem);

		// Creating new Workspace
		newWorkspaceMenuItem.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// If the workspace wasn't saved
				if (storageTabbedPane.workingareastoragepanel.coordinatesystempanel.isChanged) {
					Object[] options = { "Igen", "Nem", "Mégse" };
					int n = JOptionPane.showOptionDialog(mainFrame,
							"Szeretné menteni az előző Munkalapot? ",
							"Munkamenet mentése",
							JOptionPane.YES_NO_CANCEL_OPTION,
							JOptionPane.QUESTION_MESSAGE, null, options,
							options[2]);
					if (n == 0) {
						saveWorkingArea();
						newWorkingArea();
					} else if (n == 1) {
						System.out.println("Nem");
						newWorkingArea();
					}

					else if (n == 2) {
						// Don't do anything
						System.out.println("Mégse");
					}
				}
				// if the workspace was saved
				else {
					newWorkingArea();
				}
			}
		});

		filemenu.addSeparator();

		// Open Workspace / Picture

		JMenu openMenu = new JMenu("Megnyitás");
		openMenu.getAccessibleContext()
		.setAccessibleDescription("Megnyitás...");
		final JMenuItem openPicture = new JMenuItem("Kép megnyitása");
		openPicture.getAccessibleContext().setAccessibleDescription(
				"Megnyitás...");
		final JMenuItem openWorkspace = new JMenuItem("Munkalap megnyitása");
		openWorkspace.getAccessibleContext().setAccessibleDescription(
				"Megnyitás...");

		final JFileChooser fc = new JFileChooser();

		// fc.addChoosableFileFilter(new WorkspaceFilter());
		fc.setFileFilter(new WorkspaceFilter()); // .tdif format
		fc.setAcceptAllFileFilterUsed(false);
		openWorkspace.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				if (storageTabbedPane.workingareastoragepanel.coordinatesystempanel.isChanged) {
					Object[] options = { "Igen", "Nem", "Mégse" };
					int n = JOptionPane.showOptionDialog(mainFrame,
							"Szeretné menteni az előző Munkalapot? ",
							"Munkamenet mentése",
							JOptionPane.YES_NO_CANCEL_OPTION,
							JOptionPane.QUESTION_MESSAGE, null, options,
							options[2]);
					if (n == 0) {
						saveWorkingArea();
						openWorkspace(fc, openWorkspace);
					} else if (n == 1) {
						System.out.println("Nem");
						openWorkspace(fc, openWorkspace);
					}

					else if (n == 2) {
						// Don't do anything
						System.out.println("Mégse");
					}
				}
				// if the workspace was saved
				else {
					openWorkspace(fc, openWorkspace);
				}
			}
		});

		final JFileChooser fc2 = new JFileChooser();
		// fc2.addChoosableFileFilter(new ImageFilter());
		fc2.setFileFilter(new ImageFilter());
		fc2.setAcceptAllFileFilterUsed(false);

		openPicture.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				if (storageTabbedPane.imageeditstoragepanel.imagepanel.isTransformed == false) {
					openPicture(fc2, openPicture);
				} else {
					Object[] options = { "Igen", "Nem", "Mégse" };
					int n = JOptionPane.showOptionDialog(mainFrame,
							"Szeretné menteni a transzformált képet? ",
							"Kép mentése", JOptionPane.YES_NO_CANCEL_OPTION,
							JOptionPane.QUESTION_MESSAGE, null, options,
							options[2]);
					if (n == 0) {
						savePicture();
						openPicture(fc2, openPicture);
					} else if (n == 1) {
						System.out.println("Nem");
						openPicture(fc2, openPicture);
					}

					else if (n == 2) {
						// Don't do anything
						System.out.println("Mégse");
					}
				}
				storageTabbedPane.getImageEditStoragePanel().getImagePanel()
				.setRepairItemEnabled(false);
			}
		});

		openMenu.add(openWorkspace);
		openMenu.add(openPicture);
		filemenu.add(openMenu);

		filemenu.addSeparator();

		final JMenuItem saveMenuItem = new JMenuItem("Mentés");
		saveMenuItem.getAccessibleContext().setAccessibleDescription(
				"Munkalap vagy Kép mentése");
		saveMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,
				ActionEvent.CTRL_MASK));
		filemenu.add(saveMenuItem);
		saveMenuItem.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				if (storageTabbedPane.getSelectedIndex() == 0) {
					saveWorkingArea();
				} else {
					savePicture();

				}
			}
		});

		filemenu.addSeparator();

		JMenuItem saveAsMenuItem = new JMenuItem("Mentés másként");
		saveAsMenuItem.getAccessibleContext().setAccessibleDescription(
				"Munkalap vagy Kép mentése másként");
		// saveAsMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C,
		// ActionEvent.ALT_MASK));
		filemenu.add(saveAsMenuItem);

		final JFileChooser fc5 = new JFileChooser();
		saveAsMenuItem.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {

				if (storageTabbedPane.getSelectedIndex() == 0) {

					fc5.setFileFilter(new WorkspaceFilter());
					fc5.setAcceptAllFileFilterUsed(false);
					int returnVal = fc5.showSaveDialog(saveMenuItem);
					if (returnVal == JFileChooser.APPROVE_OPTION) {
						File file = fc5.getSelectedFile();
						isSavedWorkingArea = true;
						File outputfile;
						if (file.getName().contains(".tdif")) {
							outputfile = new File(file.getPath());
						} else {
							outputfile = new File(file.getPath() + ".tdif");
						}
						FileSaver newfilesaver = new FileSaver(
								outputfile,
								storageTabbedPane.workingareastoragepanel.coordinatesystempanel.components);
						newfilesaver.writeToFile();
						workspacefile = outputfile;
						System.out.println(file.getPath() + file.getName());
					} else {
						System.out.println("Save command cancelled by user");
					}

				} else {
					if (storageTabbedPane.imageeditstoragepanel.imagepanel.pictureOnPanel != null) {
						fc5.setFileFilter(new ImageFilter());
						fc5.setAcceptAllFileFilterUsed(false);
						int returnVal = fc5.showSaveDialog(saveMenuItem);
						if (returnVal == JFileChooser.APPROVE_OPTION) {
							File file = fc5.getSelectedFile();
							isSavedImage = true;
							BufferedImage bi = storageTabbedPane.imageeditstoragepanel.imagepanel.pictureOnPanel;
							if (bi != null) {
								File outputfile;
								if (file.getName().contains(".png")
										|| file.getName().contains(".jpg")
										|| file.getName().contains(".jpeg")
										|| file.getName().contains(".bmp")
										|| file.getName().contains(".gif")) {
									outputfile = new File(file.getPath());
								} else {
									outputfile = new File(file.getPath()
											+ ".png");
								}
								imageFile = outputfile;
								try {
									ImageIO.write(bi, "png", outputfile);
								} catch (IOException e1) {
									e1.printStackTrace();
									System.out.println("HIBA");
								}
							}

							System.out.println(file.getPath() + file.getName());
						} else {
							System.out
							.println("Save command cancelled by user");
						}
					} else {
						JOptionPane.showMessageDialog(mainFrame,
								"Nincs menthető kép", "Mentés hiba",
								JOptionPane.ERROR_MESSAGE);
					}

				}

			}
		});

		filemenu.addSeparator();

		JMenuItem undoMenuItem = new JMenuItem("Visszavonás");
		undoMenuItem.getAccessibleContext().setAccessibleDescription(
				"Visszavonás");
		undoMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z,
				ActionEvent.CTRL_MASK));
		filemenu.add(undoMenuItem);

		undoMenuItem.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				if (storageTabbedPane.getSelectedIndex() == 0) {
					storageTabbedPane.workingareastoragepanel.coordinatesystempanel.nonLinearTransformedShapes = null;
					storageTabbedPane.workingareastoragepanel.coordinatesystempanel.transformedShapes = null;
					storageTabbedPane.workingareastoragepanel.coordinatesystempanel.coloringNonLinTransformedShapes=null;
					storageTabbedPane.workingareastoragepanel.coordinatesystempanel.coloringTransformedShapes=null;
					storageTabbedPane.workingareastoragepanel.coordinatesystempanel
					.repaint();
				} else {
					storageTabbedPane.imageeditstoragepanel.imagepanel.pictureOnPanel = storageTabbedPane.imageeditstoragepanel.imagepanel.sourceImage;
					storageTabbedPane.imageeditstoragepanel.imagepanel
					.repaint();
				}

			}
		});

		JMenuItem exitMenuItem = new JMenuItem("Kilépés");
		exitMenuItem.getAccessibleContext().setAccessibleDescription(
				"Kilépés a programból.");
		exitMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X,
				ActionEvent.ALT_MASK));
		filemenu.add(exitMenuItem);

		exitMenuItem.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// Exit without saving
				if (storageTabbedPane.workingareastoragepanel.coordinatesystempanel.isChanged == true) {
					Object[] options = { "Igen", "Nem", "Mégse" };
					int n = JOptionPane.showOptionDialog(mainFrame,
							"Szeretné menteni az előző Munkalapot? ",
							"Munkamenet mentése",
							JOptionPane.YES_NO_CANCEL_OPTION,
							JOptionPane.QUESTION_MESSAGE, null, options,
							options[2]);
					if (n == 0) {
						saveWorkingArea();

					} else if (n == 1) {
						System.out.println("Nem");

					}

					else if (n == 2) {
						// Don't do anything
						System.out.println("Mégse");
					}
				}
				if (storageTabbedPane.imageeditstoragepanel.imagepanel.isTransformed == true) {
					Object[] options = { "Igen", "Nem", "Mégse" };
					int n = JOptionPane.showOptionDialog(mainFrame,
							"Szeretné menteni a transzformált képet? ",
							"Kép mentése", JOptionPane.YES_NO_CANCEL_OPTION,
							JOptionPane.QUESTION_MESSAGE, null, options,
							options[2]);
					if (n == 0) {
						savePicture();
					} else if (n == 1) {
						System.out.println("Nem");
					}

					else if (n == 2) {
						// Don't do anything
						System.out.println("Mégse");
					}
				}
				System.exit(0);

			}
		});

		JMenu helpmenu = new JMenu("Súgó");
		helpmenu.setMnemonic(KeyEvent.VK_F1);
		helpmenu.getAccessibleContext().setAccessibleDescription("Súgó");
		menubar.add(helpmenu);

		JMenuItem helpmenuitem = new JMenuItem("Keresés téma címszó segítségével");
		helpmenu.add(helpmenuitem);

		helpmenuitem.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				JPanel helpframe= new HelpPanel();

				JOptionPane.showMessageDialog(storageTabbedPane,helpframe);
				helpframe.setVisible(true);

			}
		});

	}

	public void createAndShowGUI() {
		/* JFrame */mainFrame = new JFrame("Transzformációs szoftver");

		mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		mainFrame.setSize(800, 600);
		TransformationSwMenuBar menubar = new TransformationSwMenuBar();
		setMenu(menubar);
		mainFrame.setJMenuBar(menubar);
		mainFrame.getContentPane().add(storageTabbedPane);

		mainFrame.pack();
		mainFrame.setVisible(true);
	}

	public static void main(String[] args) {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (UnsupportedLookAndFeelException e) {

		} catch (ClassNotFoundException e) {

		} catch (InstantiationException e) {

		} catch (IllegalAccessException e) {

		}

		final AppWindow appwindow = new AppWindow();

		javax.swing.SwingUtilities.invokeLater(new Runnable() {

			@Override
			public void run() {
				appwindow.createAndShowGUI();

			}
		});
	}
}
