package szakdolgozat;

import ij.ImagePlus;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.border.BevelBorder;
import javax.swing.border.EtchedBorder;

public class ImagePanel extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1742401402342543877L;
	File imagefile;
	boolean isSaved;
	int xcoordinate = 10;
	int ycoordinate = 10;
	boolean isTransformed = false;
	volatile BufferedImage pictureOnPanel;
	BufferedImage sourceImage;
	public JPopupMenu popup;
	JMenuItem repairItem;

	public ImagePanel() {
		super();
		setOpaque(true);
		setPreferredSize(new Dimension(550, 560));
		setLayout(new BorderLayout());
		setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
		pictureOnPanel = null;
		imagefile = null;
		isSaved = false;
		popup = new JPopupMenu();

		JMenuItem leftCornerItem = new JMenuItem("Kép bal felül");
		popup.add(leftCornerItem);
		leftCornerItem.setHorizontalTextPosition(JMenuItem.RIGHT);
		leftCornerItem.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				ycoordinate = 10;
				xcoordinate = 10;
				repaint();

			}
		});
		JMenuItem leftDownCornerItem = new JMenuItem("Kép bal alul");
		popup.add(leftDownCornerItem);
		leftDownCornerItem.setHorizontalTextPosition(JMenuItem.RIGHT);
		leftDownCornerItem.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				if (pictureOnPanel != null) {
					ycoordinate = 560 - pictureOnPanel.getHeight();
					xcoordinate = 10;
					repaint();
				}
			}
		});

		JMenuItem middleItem = new JMenuItem("Kép középen");
		popup.add(middleItem);
		middleItem.setHorizontalTextPosition(JMenuItem.RIGHT);
		middleItem.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				if (pictureOnPanel != null) {
					xcoordinate = 540 / 2 - pictureOnPanel.getWidth() / 2;
					ycoordinate = 560 / 2 - pictureOnPanel.getHeight() / 2;
					repaint();
				}
			}
		});

		repairItem = new JMenuItem("Kép javítása");
		popup.add(repairItem);
		repairItem.setEnabled(false);
		repairItem.setHorizontalTextPosition(JMenuItem.RIGHT);
		repairItem.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				if (pictureOnPanel != null) {
					ImagePlus imagePlus = new ImagePlus();
					imagePlus.setImage(pictureOnPanel);
					imagePlus.getProcessor().dilate();
					pictureOnPanel = imagePlus.getBufferedImage();
					repaint();
				}
			}
		});

		popup.setLabel("Képelrendezés");
		popup.setBorder(new BevelBorder(BevelBorder.RAISED));

		addMouseListener(new MousePopupListener(popup, this));

	}

	public Boolean isIsSaved() {
		return isSaved;
	}

	public void setIsSaved(boolean issaved) {
		isSaved = issaved;
	}

	@Override
	public void paint(Graphics g) {
		super.paint(g);
		Graphics2D g2 = (Graphics2D) g;

		if (pictureOnPanel != null) {

			g2.drawImage(pictureOnPanel, xcoordinate, ycoordinate, null);

		}
	}

	public void setPictureOnPanel(File image) {
		if (image != null) {
			BufferedImage img = null;
			try {
				img = ImageIO.read(image);
				pictureOnPanel = img;
				sourceImage = img;
			} catch (IOException e) {
				System.out.println("Hehe");
			}
		}
		repaint();
	}

	public void linearTransformation(String m1, String m2, String m3, String m4) {
		if (pictureOnPanel != null) {
			isTransformed = true;
			Transformation transf = new Transformation();
			BufferedImage newimg = transf.linearTransformationOfImage(
					pictureOnPanel, Double.parseDouble(m1),
					Double.parseDouble(m2), Double.parseDouble(m3),
					Double.parseDouble(m4));
			pictureOnPanel = newimg;
		} else {
			JOptionPane.showMessageDialog(this, "Nincs transzformálható kép.",
					"Transzformációs hiba", JOptionPane.ERROR_MESSAGE);
		}
	}

	public void setRepairItemEnabled(boolean value) {
		if (repairItem != null) {
			repairItem.setEnabled(value);
		}
	}


}
