package szakdolgozat;

import java.awt.Color;
import java.awt.Point;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.List;

import javax.swing.SwingUtilities;

public class Transformation {

	List<Object> tempList;
	BufferedImage image;

	public Transformation(){
		tempList=new ArrayList<Object>();
		image = null;
	}

	public Point2D.Double pontotTranszformal(Point2D P, double m1, double m2, double m3, double m4){
		double x=(m1*P.getX())+(m2*P.getY());
		double y=m3*P.getX()+m4*P.getY();
		Point2D.Double tmp=new Point2D.Double(x,y);
		return tmp;
	}

	public double nonlinearTransformPoint(Point2D.Double p,String expression){
		ExpressionSolverProgram solver= new ExpressionSolverProgram(expression,p.x,p.y);
		solver.start();
		return Double.parseDouble(solver.result);

	}

	public Point linearTransformationOfPixel(Point P, double m1, double m2, double m3, double m4){
		double x=m1*P.x+m2*P.y;
		double y=m3*P.x+m4*P.y;
		Point tmp = new Point((int)Math.round(x),(int)Math.round(y));
		return tmp;
	}

	public List<Point2D.Double> lineToPoints(Line2D.Double line){
		List<Point2D.Double> linetopoints=new ArrayList<Point2D.Double>();
		double tol;
		double ig;
		Point2D.Double elso;
		Point2D.Double masodik;
		if(line.getP1().getX()<line.getP2().getX()){
			elso=(Point2D.Double)line.getP1();
			masodik=(Point2D.Double)line.getP2();
			tol=line.getP1().getX();
			ig=line.getP2().getX();

			tol=(double)(Math.round(tol*1000))/1000;
			ig=(double)(Math.round(ig*1000))/1000;

			for(double i=tol;i<=ig;){
				i=(double)(Math.round(i*1000))/1000;
				double y=((i-elso.x)*(masodik.y-elso.y))/(masodik.x-elso.x)+elso.y;
				y=(double)(Math.round(y*1000))/1000;
				linetopoints.add(new Point2D.Double(i,y));
				i+=0.01;
			}
		}else if(line.getP1().getX()==line.getP2().getX()){
			if(line.getP1().getY()<line.getP2().getY()){
				elso=(Point2D.Double)line.getP1();
				masodik=(Point2D.Double)line.getP2();
				tol=line.getP1().getY();
				ig=line.getP2().getY();

				tol=(double)(Math.round(tol*1000))/1000;
				ig=(double)(Math.round(ig*1000))/1000;
			}else{
				elso=(Point2D.Double)line.getP2();
				masodik=(Point2D.Double)line.getP1();
				tol=line.getP2().getY();
				ig=line.getP1().getY();


				tol=(double)(Math.round(tol*100))/100;
				ig=(double)(Math.round(ig*100))/100;
			}

			for(double i=tol;i<=ig;){
				i=(double)(Math.round(i*100))/100;
				linetopoints.add(new Point2D.Double(line.getP1().getX(),i));
				i+=0.01;
			}

		}
		else{
			elso=(Point2D.Double)line.getP2();
			masodik=(Point2D.Double)line.getP1();
			tol=line.getP2().getX();
			ig=line.getP1().getX();

			tol=(double)(Math.round(tol*100))/100;
			ig=(double)(Math.round(ig*100))/100;

			for(double i=tol;i<=ig;){
				i=(double)(Math.round(i*100))/100;
				double y=((i-elso.x)*(masodik.y-elso.y))/(masodik.x-elso.x)+elso.y;
				y=(double)(Math.round(y*100))/100;
				linetopoints.add(new Point2D.Double(i,y));
				i+=0.01;
			}
		}

		return linetopoints;
	}


	public List<Point2D.Double> polygonToPoints(MyPolygon polygon){
		List<Point2D.Double> p=new ArrayList<Point2D.Double>();

		for(int i=1;i<polygon.n;i++){
			List<Point2D.Double> cs=lineToPoints(new Line2D.Double((polygon.pontok)[i-1],(polygon.pontok)[i]));
			for(int j=0;j<cs.size();j++){
				p.add(cs.get(j));
			}
		}
		List<Point2D.Double> cs=lineToPoints(new Line2D.Double((polygon.pontok)[polygon.n-1],(polygon.pontok)[0]));
		for(int j=0;j<cs.size();j++){
			p.add(cs.get(j));
		}

		return p;
	}

	public List<Object> linearTransformationWorkspace(List<Object> list, double m1, double m2, double m3, double m4){
		//ArrayList<Object> tempList;

		for(int i=0;i<list.size();i++){
			if(list.get(i) instanceof Point2D.Double){
				tempList.add(pontotTranszformal((Point2D.Double)list.get(i), m1, m2, m3, m4));
			}

			else if(list.get(i) instanceof Line2D.Double){
				tempList.add(new Line2D.Double(pontotTranszformal(((Line2D.Double)list.get(i)).getP1(), m1, m2, m3, m4),
						pontotTranszformal(((Line2D.Double)list.get(i)).getP2(), m1, m2, m3, m4)));
			}

			else if(list.get(i) instanceof MyPolygon) {
				Point2D.Double[] pontok = new Point2D.Double [((MyPolygon)list.get(i)).n];
				int n=((MyPolygon)list.get(i)).n;
				for(int j=0;j<n;j++){
					double x=(((MyPolygon)list.get(i)).pontok)[j].x;
					double y=(((MyPolygon)list.get(i)).pontok)[j].y;
					Point2D.Double P=new Point2D.Double(x,y);
					pontok[j]=pontotTranszformal(P, m1, m2, m3, m4);
				}
				MyPolygon newPolygon = new MyPolygon(pontok,n);
				tempList.add(newPolygon);
			}

			else if(list.get(i) instanceof MyCircle) {
				MyCircle circle=new MyCircle(pontotTranszformal(((MyCircle)list.get(i)).O, m1, m2, m3, m4), ((MyCircle)list.get(i)).r);
				circle.pointsOfCircle=null;
				circle.pointsOfCircle=new ArrayList<Point2D.Double>();
				for(int j=0;j<((MyCircle)list.get(i)).pointsOfCircle.size();j++){
					circle.pointsOfCircle.add(pontotTranszformal(((MyCircle)list.get(i)).pointsOfCircle.get(j), m1, m2, m3, m4));

				}
				tempList.add(circle);
			}
			else if(list.get(i) instanceof MyFunction) {
				MyFunction function=new MyFunction(((MyFunction)list.get(i)).getF());
				function.pointList=null;
				function.pointList=new ArrayList<Point2D.Double>();
				for(int j=0;j<((MyFunction)list.get(i)).pointList.size();j++){
					function.pointList.add(pontotTranszformal(((MyFunction)list.get(i)).pointList.get(j), m1, m2, m3, m4));

				}
				tempList.add(function);
			}
		}

		return tempList;
	}

	public BufferedImage linearTransformationOfImage(BufferedImage pic, double m1, double m2, double m3, double m4){
		BufferedImage tempPic;
		tempPic = new BufferedImage(600, 600, BufferedImage.TYPE_INT_RGB );
		for(int i=0;i<600;i++){
			for(int j=0;j<600;j++){
				tempPic.setRGB(i, j, Color.WHITE.getRGB());
			}
		}
		int n=pic.getHeight();
		int m=pic.getWidth();
		for(int i=0;i<m;i++){
			for(int j=0;j<n;j++){
				Point p=linearTransformationOfPixel(new Point(i,j), m1, m2, m3, m4);
				if(p.x<600 && p.x>0 && p.y<600 && p.y>0) {
					tempPic.setRGB(p.x, p.y, pic.getRGB(i, j));
				}
			}
		}

		return tempPic;
	}

	public List<Object> nonlinearTransformationOfWorkspace(List<Object> list, String expression1, String expression2){
		List<Object> tempList;
		tempList=new ArrayList<Object>();
		for(int i=0;i<list.size();i++){
			if(list.get(i) instanceof Line2D.Double){
				List<Point2D.Double> ponthalmaz = lineToPoints((Line2D.Double)list.get(i));

				List<Point2D.Double> transformedponthalmaz = new ArrayList<Point2D.Double>();
				for(int j=0;j<ponthalmaz.size();j++){
					double x=nonlinearTransformPoint(ponthalmaz.get(j), expression1);
					double y=nonlinearTransformPoint(ponthalmaz.get(j), expression2);

					x=(double)(Math.round(x*100))/100;
					y=(double)(Math.round(y*100))/100;

					transformedponthalmaz.add(new Point2D.Double(x,y));

				}

				TransformedLine tl = new TransformedLine(transformedponthalmaz);
				tempList.add(tl);
			}
			else if(list.get(i) instanceof Point2D.Double){
				tempList.add(new Point2D.Double(nonlinearTransformPoint((Point2D.Double)list.get(i), expression1),nonlinearTransformPoint((Point2D.Double)list.get(i), expression2)));
			}

			else if(list.get(i) instanceof MyCircle){
				List<Point2D.Double> ponthalmaz = ((MyCircle)(list.get(i))).pointsOfCircle;
				List<Point2D.Double> transformedponthalmaz = new ArrayList<Point2D.Double>();
				for(int j=0;j<ponthalmaz.size();j++){
					double x=nonlinearTransformPoint(ponthalmaz.get(j), expression1);
					double y=nonlinearTransformPoint(ponthalmaz.get(j), expression2);

					x=(double)(Math.round(x*100))/100;
					y=(double)(Math.round(y*100))/100;

					transformedponthalmaz.add(new Point2D.Double(x,y));

				}
				TransformedShape ts = new TransformedShape(transformedponthalmaz.size(),transformedponthalmaz);
				tempList.add(ts);

			}
			//
			else if(list.get(i) instanceof MyFunction) {

				List<Point2D.Double> ponthalmaz = ((MyFunction)(list.get(i))).pointList;
				List<Point2D.Double> transformedponthalmaz = new ArrayList<Point2D.Double>();
				for(int j=0;j<ponthalmaz.size();j++){
					double x=nonlinearTransformPoint(ponthalmaz.get(j), expression1);
					double y=nonlinearTransformPoint(ponthalmaz.get(j), expression2);

					x=(double)(Math.round(x*100))/100;
					y=(double)(Math.round(y*100))/100;

					transformedponthalmaz.add(new Point2D.Double(x,y));

				}
				TransformedShape ts = new TransformedShape(transformedponthalmaz.size(),transformedponthalmaz);
				tempList.add(ts);
			}

		}

		return tempList;
	}


	public BufferedImage nonlinearTransformationPicture(BufferedImage pic, String expression1, String expression2){
		BufferedImage tempPic;
		tempPic = new BufferedImage(600, 600, BufferedImage.TYPE_INT_RGB );
		System.out.println(pic.getWidth());
		System.out.println(pic.getHeight());
		for(int i=0;i<600;i++){
			for(int j=0;j<600;j++){
				tempPic.setRGB(i, j, Color.WHITE.getRGB());
			}
		}

		int m=pic.getWidth();

		int processors = Runtime.getRuntime().availableProcessors();
		for (int i = 0; i < processors; i++) {
			int xFrom = m/processors*i;
			int xTo = m/processors*(i+1);
			Runnable transformationThread = new TransformationThread(pic, tempPic, xFrom, xTo,  expression1, expression2);
			SwingUtilities.invokeLater(transformationThread);
		}


		return tempPic;
	}

}
