package szakdolgozat;

import java.awt.Point;
import java.awt.geom.Point2D;
import java.awt.image.BufferedImage;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicBoolean;

import javax.swing.JOptionPane;

public class TransformationThread implements Runnable {

	public static final AtomicBoolean wasErrorMsgDisplayed = new AtomicBoolean(
			false);
	private BufferedImage inputImage;
	private int xFrom;
	private int xTo;
	private BufferedImage resultImage;
	private String expr2;
	private String expr1;

	public TransformationThread(BufferedImage inputImage,
			BufferedImage resultImage, int xFrom, int xTo, String expr1,
			String expr2) {
		this.resultImage = resultImage;
		this.inputImage = inputImage;
		this.xFrom = xFrom;
		this.xTo = xTo;
		this.expr1 = expr1;
		this.expr2 = expr2;
	}

	@Override
	public void run() {
		long startTime = System.nanoTime();
		try {
			for (int i = xFrom; i < xTo; i++) {
				for (int j = 0; j < inputImage.getHeight(); j++) {
					Point p = new Point((int) (nonLinearTransformation(
							new Point2D.Double(i, j), expr1)),
							(int) (nonLinearTransformation(new Point2D.Double(i, j),
									expr2)));
					if (p.x < 600 && p.y < 600 && p.x > 0 && p.y > 0) {
						resultImage.setRGB(p.x, p.y, inputImage.getRGB(i, j));
					}
				}
			}
		}catch(NumberFormatException e) {
			if(wasErrorMsgDisplayed.compareAndSet(false, true)) {
				JOptionPane.showMessageDialog(null,
					    "Hibás bemenet",
					    "Transzformációs hiba",
					    JOptionPane.ERROR_MESSAGE);
			}
		}
		
		resultImage.flush();
		System.out.println("Transzformáció futott " + TimeUnit.NANOSECONDS.toMillis(System.nanoTime()-startTime) + "milliszekundumig.");
	}

	public double nonLinearTransformation(Point2D.Double p, String expression) {
		ExpressionSolverProgram solver = new ExpressionSolverProgram(expression, p.x, p.y);
		solver.start();
		return Double.parseDouble(solver.result);
	}
}
